module CStringConfiguration
	use CStringConfigurationVariables
	use ConfigurationVariables
	
	implicit none    
	public    
    contains
    
	integer function SetStringConfigurations(count, array, bit)
	!DEC$ ATTRIBUTES DLLEXPORT::SetStringConfigurations
	!DEC$ ATTRIBUTES ALIAS: 'SetStringConfigurations' :: SetStringConfigurations
        use CManifolds
		implicit none
		integer, intent(in) :: count
		integer :: i, j
		type(CStringItem), intent(inout), target :: array(count)            
		type(CBitInfo), intent(inout) :: bit
		type(CStringItem), pointer :: item            
		data%Configuration%StringConfiguration%BitDefinition%BitType            = bit%BitType
		data%Configuration%StringConfiguration%BitDefinition%BitSize            = bit%BitSize
		data%Configuration%StringConfiguration%BitDefinition%BitCodeHundreds    = bit%BitCodeHundreds
		data%Configuration%StringConfiguration%BitDefinition%BitCodeTens        = bit%BitCodeTens
		data%Configuration%StringConfiguration%BitDefinition%BitCodeOnes        = bit%BitCodeOnes
		data%Configuration%StringConfiguration%BitDefinition%BitNozzleSize      = bit%BitNozzleSize
		data%Configuration%StringConfiguration%BitDefinition%BitLength          = bit%BitLength
		data%Configuration%StringConfiguration%BitDefinition%BitWeightPerLength = bit%BitWeightPerLength
		data%Configuration%StringConfiguration%BitDefinition%BitNozzleNo        = bit%BitNozzleNo
		data%Configuration%StringConfiguration%BitDefinition%FloatValve         = bit%FloatValve            
		data%Configuration%StringConfiguration%StringConfigurationCount         = count
            
        if(data%Configuration%StringConfiguration%BitDefinition%FloatValve) then
            call InstallFloatValve()
        else
            call RemoveFloatValve()
        endif
            
		if(size(data%Configuration%StringConfiguration%StringConfigurations) > 0) then
			deallocate(data%Configuration%StringConfiguration%StringConfigurations)
		end if
		if(count > 0) then
			allocate(data%Configuration%StringConfiguration%StringConfigurations(count))
            !j = count
			do i = 1, count
				item => array(i)
				data%Configuration%StringConfiguration%StringConfigurations(i)%ComponentType      = item%ComponentType     
				data%Configuration%StringConfiguration%StringConfigurations(i)%NumberOfJoint      = item%NumberOfJoint
				data%Configuration%StringConfiguration%StringConfigurations(i)%LengthPerJoint     = item%LengthPerJoint
				data%Configuration%StringConfiguration%StringConfigurations(i)%NominalOd          = item%NominalOd    
				data%Configuration%StringConfiguration%StringConfigurations(i)%NominalId          = item%NominalId
				data%Configuration%StringConfiguration%StringConfigurations(i)%WeightPerLength    = item%WeightPerLength                    
				data%Configuration%StringConfiguration%StringConfigurations(i)%ComponentLength    = item%ComponentLength
				data%Configuration%StringConfiguration%StringConfigurations(i)%NominalToolJointOd = item%NominalToolJointOd
				data%Configuration%StringConfiguration%StringConfigurations(i)%Grade              = item%Grade
                !print*, 'type=', StringConfigurations(i)%ComponentType 
                !print*, 'NumberOfJoint=', StringConfigurations(i)%NumberOfJoint
                !print*, '-----------------------------------------------------------'
                !j = j - 1
            end do
        end if
            
		SetStringConfigurations = 0
    end function SetStringConfigurations
    
end module CStringConfiguration